import { IClaim } from '@energyweb/issuer';
import { ICertificateReadModel } from '../../types';
import { CertificateEventType } from '../../events/Certificate.events';
export declare const tableName = "certificate_read_model";
export declare class CertificateReadModelEntity<MetadataType> implements ICertificateReadModel<MetadataType> {
    createdAt: Date;
    internalCertificateId: number;
    blockchainCertificateId: number | null;
    deviceId: string;
    generationStartTime: number;
    generationEndTime: number;
    creationTime: number;
    owners: Record<string, string>;
    claimers: Record<string, string> | null;
    claims: IClaim[];
    creationBlockHash: string;
    metadata: MetadataType;
    isSynced: boolean;
    transactions: CertificateTransaction[];
    updatedAt: Date;
}
export interface CertificateTransaction {
    transactionHash: string;
    eventType: CertificateEventType;
    timestamp: Date;
}
