import { SynchronizeStrategy } from '../synchronize.strategy';
import { CertificateEventRepository } from '../../../repositories/CertificateEvent/CertificateEvent.repository';
import { ICertificateEvent } from '../../../events/Certificate.events';
import { ClaimPersistHandler } from '../../handlers/claim-persist.handler';
import { IssuePersistHandler } from '../../handlers/issue-persist.handler';
import { TransferPersistHandler } from '../../handlers/transfer-persist.handler';
export declare class BatchSynchronizeStrategy implements SynchronizeStrategy {
    private eventRepository;
    private claimPersistHandler;
    private issuancePersistHandler;
    private transferPersistHandler;
    private logger;
    constructor(eventRepository: CertificateEventRepository, claimPersistHandler: ClaimPersistHandler, issuancePersistHandler: IssuePersistHandler, transferPersistHandler: TransferPersistHandler);
    synchronize(events: ICertificateEvent[]): Promise<void>;
    private getEventsWithBlockchainId;
}
