import { IClaimCommand, IIssueCommand, ITransferCommand } from '../../types';
import { CertificateClaimedEvent, CertificateIssuedEvent, CertificateTransferredEvent, ICertificateEvent } from '../events/Certificate.events';
import { CertificateAggregate } from '../certificate.aggregate';
export declare const groupByInternalCertificateId: <T extends {
    internalCertificateId: number;
}>(entityWithCertificateId: T[]) => Record<number, T[]>;
export declare const createAggregatesFromCertificateGroups: <T>(certificateEventsGroups: Record<number, ICertificateEvent[]>, createAggregateFunction: (events: ICertificateEvent[]) => Promise<CertificateAggregate<T>>) => Promise<CertificateAggregate<T>[]>;
export declare const createEventFromCommand: (command: IClaimCommand | ITransferCommand) => CertificateTransferredEvent | CertificateClaimedEvent;
export declare const createIssueEventsFromCommands: <T>(commands: IIssueCommand<T>[], getIdFunction: () => Promise<number>) => Promise<CertificateIssuedEvent<T>[]>;
export declare const isTransferCommand: (command: IClaimCommand | ITransferCommand) => command is ITransferCommand;
export declare const zipEventsWithCommandId: (events: ICertificateEvent[], commands: {
    id: number;
}[]) => {
    commandId: number;
    id: number;
    type: import("../events/Certificate.events").CertificateEventType;
    version: number;
    internalCertificateId: number;
    payload: unknown;
    createdAt: Date;
}[];
