"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateBatchTransferCommands = exports.validateTransferCommand = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const validator_config_1 = require("./validator.config");
const is_energy_value_1 = require("./decorators/is-energy-value");
const validateTransferCommand = async (command) => await class_validator_1.validateOrReject(class_transformer_1.plainToClass(TransferCommandDto, command), validator_config_1.validatorOptions);
exports.validateTransferCommand = validateTransferCommand;
const validateBatchTransferCommands = async (commands) => {
    const validationErrors = await Promise.all(commands.map((command) => class_validator_1.validate(class_transformer_1.plainToClass(TransferCommandDto, command))));
    if (validationErrors.every((errors) => errors.length === 0)) {
        return;
    }
    throw validationErrors;
};
exports.validateBatchTransferCommands = validateBatchTransferCommands;
class TransferCommandDto {
}
__decorate([
    class_validator_1.IsNumber(),
    class_validator_1.Min(0),
    __metadata("design:type", Number)
], TransferCommandDto.prototype, "certificateId", void 0);
__decorate([
    class_validator_1.IsEthereumAddress(),
    __metadata("design:type", String)
], TransferCommandDto.prototype, "fromAddress", void 0);
__decorate([
    class_validator_1.IsEthereumAddress(),
    __metadata("design:type", String)
], TransferCommandDto.prototype, "toAddress", void 0);
__decorate([
    is_energy_value_1.IsEnergyValue(),
    __metadata("design:type", String)
], TransferCommandDto.prototype, "energyValue", void 0);
//# sourceMappingURL=transfer-command.validator.js.map