"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var BlockchainActionsProcessor_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlockchainActionsProcessor = exports.blockchainQueueName = void 0;
const bull_1 = require("@nestjs/bull");
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const certificate_operations_service_1 = require("./certificate-operations/certificate-operations.service");
exports.blockchainQueueName = 'blockchain-actions';
let BlockchainActionsProcessor = BlockchainActionsProcessor_1 = class BlockchainActionsProcessor {
    constructor(configService, certificateOperationsFacade) {
        this.configService = configService;
        this.certificateOperationsFacade = certificateOperationsFacade;
        this.logger = new common_1.Logger(BlockchainActionsProcessor_1.name);
    }
    async handle(payload) {
        try {
            const result = await this.certificateOperationsFacade.process(payload);
            await new Promise((resolve) => setTimeout(resolve, this.configService.get('CERTIFICATE_QUEUE_DELAY')));
            return result;
        }
        catch (e) {
            this.logger.error(`Error on job ${JSON.stringify(payload.data)}: ${e.message}`, e.stack);
            throw e;
        }
    }
};
__decorate([
    bull_1.Process({ concurrency: 1 }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], BlockchainActionsProcessor.prototype, "handle", null);
BlockchainActionsProcessor = BlockchainActionsProcessor_1 = __decorate([
    bull_1.Processor(exports.blockchainQueueName),
    __metadata("design:paramtypes", [config_1.ConfigService,
        certificate_operations_service_1.CertificateOperationsService])
], BlockchainActionsProcessor);
exports.BlockchainActionsProcessor = BlockchainActionsProcessor;
//# sourceMappingURL=blockchain-actions.processor.js.map