import { Job } from 'bull';
import { BlockchainAction } from '../types';
import { TransactionPollService } from './transaction-poll.service';
import { BatchClaimCertificatesHandler } from './claim/batch-claim-certificates.handler';
import { BatchIssueCertificatesHandler } from './issue/batch-issue-certificates.handler';
import { BatchTransferCertificatesHandler } from './transfer/batch-transfer-certificates.handler';
import { ClaimCertificateHandler } from './claim/claim-certificate.handler';
import { IssueCertificateHandler } from './issue/issue-certificate.handler';
import { TransferCertificateHandler } from './transfer/transfer-certificate.handler';
export declare class CertificateOperationsService {
    private readonly transactionPoll;
    private readonly batchClaimCertificatesHandler;
    private readonly batchIssueCertificatesHandler;
    private readonly batchTransferCertificatesHandler;
    private readonly claimCertificateHandler;
    private readonly issueCertificateHandler;
    private readonly transferCertificateHandler;
    private readonly logger;
    constructor(transactionPoll: TransactionPollService, batchClaimCertificatesHandler: BatchClaimCertificatesHandler, batchIssueCertificatesHandler: BatchIssueCertificatesHandler, batchTransferCertificatesHandler: BatchTransferCertificatesHandler, claimCertificateHandler: ClaimCertificateHandler, issueCertificateHandler: IssueCertificateHandler, transferCertificateHandler: TransferCertificateHandler);
    process({ data }: Job<BlockchainAction>): Promise<BatchIssuanceActionResult | BatchTransferActionResult | BatchClaimActionResult | IssuanceActionResult<any> | TransferActionResult | ClaimActionResult>;
    private issue;
    private transfer;
    private claim;
    private batchIssue;
    private batchTransfer;
    private batchClaim;
}
declare type TransactionHashResult = {
    transactionHash: string;
};
export declare type BatchIssuanceActionResult = {
    certificateIds: number[];
} & TransactionHashResult;
export declare type BatchTransferActionResult = TransactionHashResult;
export declare type BatchClaimActionResult = TransactionHashResult;
export declare type IssuanceActionResult<MetadataType> = {
    certificateId: number;
} & TransactionHashResult;
export declare type TransferActionResult = TransactionHashResult;
export declare type ClaimActionResult = TransactionHashResult;
export {};
