"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClaimCertificateHandler = void 0;
const issuer_1 = require("@energyweb/issuer");
const ethers_1 = require("ethers");
const common_1 = require("@nestjs/common");
const blockchain_properties_service_1 = require("../../blockchain-properties.service");
let ClaimCertificateHandler = class ClaimCertificateHandler {
    constructor(blockchainPropertiesService) {
        this.blockchainPropertiesService = blockchainPropertiesService;
    }
    async execute({ certificateId, claimData, forAddress, energyValue }) {
        const blockchainProperties = await this.blockchainPropertiesService.getWrapped();
        const cert = await new issuer_1.Certificate(certificateId, blockchainProperties, issuer_1.CertificateSchemaVersion.Latest);
        return await cert.claim(claimData, ethers_1.BigNumber.from(energyValue), forAddress, forAddress);
    }
};
ClaimCertificateHandler = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [blockchain_properties_service_1.BlockchainPropertiesService])
], ClaimCertificateHandler);
exports.ClaimCertificateHandler = ClaimCertificateHandler;
//# sourceMappingURL=claim-certificate.handler.js.map