"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BatchIssueCertificatesHandler = void 0;
const issuer_1 = require("@energyweb/issuer");
const common_1 = require("@nestjs/common");
const ethers_1 = require("ethers");
const blockchain_properties_service_1 = require("../../blockchain-properties.service");
let BatchIssueCertificatesHandler = class BatchIssueCertificatesHandler {
    constructor(blockchainPropertiesService) {
        this.blockchainPropertiesService = blockchainPropertiesService;
    }
    async execute({ certificates }) {
        const blockchainProperties = await this.blockchainPropertiesService.getWrapped();
        try {
            return issuer_1.CertificateBatchOperations.issueCertificates(certificates.map((info) => ({
                to: info.toAddress,
                deviceId: info.deviceId,
                generationStartTime: info.fromTime,
                generationEndTime: info.toTime,
                amount: ethers_1.BigNumber.from(info.energyValue),
                metadata: JSON.stringify(info.metadata)
            })), blockchainProperties);
        }
        catch (error) {
            throw new common_1.HttpException(JSON.stringify(error), common_1.HttpStatus.FAILED_DEPENDENCY);
        }
    }
};
BatchIssueCertificatesHandler = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [blockchain_properties_service_1.BlockchainPropertiesService])
], BatchIssueCertificatesHandler);
exports.BatchIssueCertificatesHandler = BatchIssueCertificatesHandler;
//# sourceMappingURL=batch-issue-certificates.handler.js.map