"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSelectDeploymentPropertiesQuery = exports.deployContracts = void 0;
const issuer_1 = require("@energyweb/issuer");
const ethers_1 = require("ethers");
async function deployContracts(web3, issuerPrivateKey) {
    const provider = new ethers_1.providers.FallbackProvider([new ethers_1.providers.JsonRpcProvider(web3)]);
    const registry = await issuer_1.Contracts.migrateRegistry(provider, issuerPrivateKey);
    const issuer = await issuer_1.Contracts.migrateIssuer(provider, issuerPrivateKey, registry.address);
    return {
        registry: registry.address,
        issuer: issuer.address,
        insertQuery: `INSERT INTO certificate_deployment_properties VALUES ('${registry.address}', '${issuer.address}');`
    };
}
exports.deployContracts = deployContracts;
function getSelectDeploymentPropertiesQuery() {
    return `SELECT * FROM certificate_deployment_properties;`;
}
exports.getSelectDeploymentPropertiesQuery = getSelectDeploymentPropertiesQuery;
//# sourceMappingURL=deployContracts.js.map