import { OnChainCertificateService } from './onchain-certificate.service';
import { IClaimCommand, IIssueCommandParams, ITransferCommand } from '../types';
declare type PublicPart<T> = {
    [K in keyof T]: T[K];
};
export declare class CertificateForUnitTestsService<T> implements PublicPart<OnChainCertificateService<T>> {
    protected serial: number;
    private db;
    issue(params: IIssueCommandParams<T>): Promise<number>;
    claim(command: IClaimCommand): Promise<void>;
    transfer(command: ITransferCommand): Promise<void>;
    batchIssue(originalCertificates: IIssueCommandParams<T>[]): Promise<number[]>;
    batchClaim(command: IClaimCommand[]): Promise<void>;
    batchTransfer(command: ITransferCommand[]): Promise<void>;
    batchIssueWithTxHash(command: IIssueCommandParams<T>[]): Promise<{
        certificateIds: number[];
        transactionHash: string;
    }>;
    batchTransferWithTxHash(command: ITransferCommand[]): Promise<{
        transactionHash: string;
    }>;
    batchClaimWithTxHash(command: IClaimCommand[]): Promise<{
        transactionHash: string;
    }>;
    issueWithTxHash<T>(command: IIssueCommandParams<T>): Promise<{
        certificateId: number;
        transactionHash: string;
    }>;
    transferWithTxHash(command: ITransferCommand): Promise<{
        transactionHash: string;
    }>;
    claimWithTxHash(command: IClaimCommand): Promise<{
        transactionHash: string;
    }>;
}
export {};
