"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitForState = void 0;
const waitForState = async (requestedStateChecker, errorMessage, { interval = 5000, maxTries = 12, delay = 0 } = {}) => {
    let currentTries = 0;
    await new Promise((resolve) => setTimeout(resolve, delay));
    return await new Promise((resolve, reject) => {
        const checkInterval = setInterval(async () => {
            if (currentTries > maxTries) {
                clearInterval(checkInterval);
                reject(errorMessage);
            }
            const hasRequestedState = await requestedStateChecker();
            if (hasRequestedState) {
                clearInterval(checkInterval);
                resolve(true);
            }
            else {
                currentTries++;
            }
        }, interval);
    });
};
exports.waitForState = waitForState;
//# sourceMappingURL=wait.utils.js.map